(***********************************************************************)
(*                                                                     *)
(*                           Objective Caml                            *)
(*                                                                     *)
(*            Xavier Leroy, projet Cristal, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* $Id: nsyntaxerr.mli,v 1.1.1.1 2002/01/16 09:01:22 cookcu Exp $ *)

(* Auxiliary type for reporting syntax errors *)

type err_kinds = IllegalAsPat | IllegalLabel | IllegalField | IllegalPat
               | IllegalRecBind | UnknownError | IllegalExpSeq
			   | IllegalType | IllegalTypeId | IllegalExp | IllegalVarId
			   | IllegalTypeVar | IllegalConId | IllegalDec | IllegalStrId
			   | IllegalFctId | IllegalSigId | IllegalStrExp | IllegalSigExp

type errmsg_kinds = EngGentle | HanGentle | HanTough

type error =
    Unclosed of Location.t * string * Location.t * string
  | Duptyid of Location.t * Location.t * string
  | Dupdatacon of Location.t * Location.t * string
  | Duppatvar of Location.t * Location.t * string
  | Orpaterr of Location.t
  | Other of Location.t * err_kinds

exception Error of error
exception Escape_error

val errmsg_type: errmsg_kinds ref
val report_error: error -> unit
