/***********************************************************************/
/*                                                                     */
/*                           Objective Caml                            */
/*                                                                     */
/*            Xavier Leroy, projet Cristal, INRIA Rocquencourt         */
/*                                                                     */
/*  Copyright 2000 Institut National de Recherche en Informatique et   */
/*  en Automatique.  All rights reserved.  This file is distributed    */
/*  under the terms of the GNU Library General Public License, with    */
/*  the special exception on linking described in file ../LICENSE.     */
/*                                                                     */
/***********************************************************************/

/* $Id: dynlink.h,v 1.1.1.1 2002/01/16 09:01:25 cookcu Exp $ */

/* Dynamic loading of C primitives. */

#ifndef _dynlink_
#define _dynlink_

#include "misc.h"

/* Build the table of primitives, given a search path, a list
   of shared libraries, and a list of primitive names
   (all three 0-separated in char arrays).
   Abort the runtime system on error. */
extern void build_primitive_table(char * lib_path,
                                  char * libs,
                                  char * req_prims);

/* The search path for shared libraries */
extern struct ext_table shared_libs_path;

#endif
