/***********************************************************************
   The yacc generator, that emits codes in N.
   Adapted from the Objective Caml's Yacc.

   Sunae Seo, The LET Project, KAIST

   Copyright 2000 Research On Program Analysis System
   National Creative Research Initiative Center
   Korea Advanced Institute of Science & Technology
   http://ropas.kaist.ac.kr

   All rights reserved. This file is distributed under the terms of
   an Open Source License.
*************************************************************************/


#include "defs.h"

char *header[] =
{
  "open Parsing",
  0
};

char *define_tables[] =
{
  "val yytables =",
  "  { actions=yyact,",
  "    transl_const=yytransl_const,",
  "    transl_block=yytransl_block,",
  "    lhs=yylhs,",
  "    len=yylen,",
  "    defred=yydefred,",
  "    dgoto=yydgoto,",
  "    sindex=yysindex,",
  "    rindex=yyrindex,",
  "    gindex=yygindex,",
  "    tablesize=yytablesize,",
  "    table=yytable,",
  "    check=yycheck,",
  "    error_function=parse_error,",
  "    names_const=yynames_const,",
  "    names_block=yynames_block }",
  0
};

void write_section(char **section)
{
    register int i;
    register FILE *fp;

    fp = code_file;
    for (i = 0; section[i]; ++i)
    {
	++outline;
	fprintf(fp, "%s\n", section[i]);
    }
}
